----------------------------------------
-- 
----------------------------------------
on startMovie
  getFormatsInClipboard()
end

----------------------------------------
-- 
----------------------------------------
on stopMovie
  if the runmode contains "author" then
    m=new(#bitmap, member(15))
    m.name="img"
    
    put "" into member("formatlist")
    put "" into member("txt")
    put "" into member("msg")
  end if
  
  file_delete(the moviepath&"~tmp.bmp") 
end

----------------------------------------
-- 
----------------------------------------
on str_repeat (input, multiplier)
  str=""
  repeat with i = 1 to multiplier
    put input after str
  end repeat
  return str
end

----------------------------------------
-- 
----------------------------------------
on getFormatsInClipboard
  l=clipGetFormats()
  formatList=[]
  formatNames=[]
  str=""
  repeat with f in l
    formatList.add(f)
    fs=string(f)
    put fs after str
    put str_repeat(SPACE, 7-fs.length) after str
    fn=clipGetFormatName(f)
    formatNames.add(fn)
    put fn & RETURN after str
  end repeat
  delete the last char of str
  member("formatlist").text = str
  
  sendAllSprites(#setFormatList, formatList)
  sendAllSprites(#setFormatNames, formatNames)
  
  sendAllSprites(#showRadio, ["hex","txt"])
end

----------------------------------------
-- 
----------------------------------------
on showData  
  f=sprite(2).pFormat
  if voidP(f) then return
  
  str = clipGetData(f)
  
  typeList = [:]
  sendAllSprites(#appendFDFData, typeList)
  display = typeList["display"]
  
  if (display="image") then
    
    if sprite(2).pFormat=8 OR sprite(2).pFormat=2 then
      str = getBmpFromDib(str)
      
      file_put_contents (the moviepath&"~tmp.bmp", str)
      
      img=member("img")
      img.filename=the moviepath&"~tmp.bmp"
      img.centerRegPoint = TRUE
      
      -- scale
      w=img.width
      h=img.height
      maxw=490.0
      maxh=410.0
      s=sprite(14)
      if w<=maxw and h<=maxh then
        s.width=w
        s.height=h
      else
        if w/maxw > h/maxh then
          s.width=maxw
          s.height=maxw*h/w
        else
          s.height=maxh
          s.width=maxh*w/h
        end if
      end if
      
      go "IMG"
      return
    end if
  end if
  
  
  if display="unicode" then
    htmlStr = ""
    cnt = str.length/2
    repeat with i=1 to cnt
      c1 = str.char[2*i-1]
      c2 = str.char[2*i]
      o1 = ord(c1)
      o2 = ord(c2)
      if o1=13 and o2=0 then next repeat 
      else if o2=0 AND o1<128 then put c1 after htmlStr
      else put "&#" & (o1+o2*256) & ";" after htmlStr
    end repeat
    sendAllSprites(#setFlashHtml, htmlStr)
    go "UNI"
    return
  end if
  
  
  if str.length>20480 then
    put "Large amount of clipboard data! Only the first 20 KB are displayed!" into member("msg")
    str=str.char[1..20480]
  else
    put SPACE into member("msg")
  end if
  
  case (display) of
    "txt":
      resetTxt()
      member("txt").text=str
      
    "rtf":
      member("txt").rtf=str
      
    "html":
      htmlStart=offset("<HTML",str)
      member("txt").html=str.char[htmlStart..str.length]
      
    otherwise:
      resetTxt()
      member("txt").text=getHexDisplay(str)
  end case
  member("txt").scrollTop=0
  go "START"
end

on resetTxt
  m=member("txt")
  m.font="Courier New"
  m.color=RGB("#000000")
  m.bgcolor=RGB("#FFFFFF")
  m.fontsize=11
  m.fontstyle=[#plain]
  m.fixedlinespace=0
end

----------------------------------------
-- 
----------------------------------------
on getHexDisplay (str)
  hex=""
  l=str.length
  cnt=ceil(l/16)
  bool=0
  repeat with i = 0 to cnt
    s=""
    h=""
    repeat with j = 1 to 16 -- cols
      n=i*16+j
      if n>l then
        bool=1          
        exit repeat
      end if
      c=str.char[n]
      cn=charToNum(c)
      put rgb(0,0,cn).hexString().char[6..7] & " " after h -- fastest dec2hex-conversion!
      if cn<20 then c="."
      put c after s
    end repeat
    
    if bool then
      put h after hex
      repeat with k=1 to ((17-j)*3+2)
        put SPACE after hex
      end repeat
      put s &RETURN after hex
    else
      put h &"  "& s &RETURN after hex
    end if
    
  end repeat
  return hex
end

----------------------------------------
-- returns binary string representation for number (little-endian)
----------------------------------------
on getBinStr (n, digits)
  s=""
  repeat with i = digits down to 1
    ex = power(256,i-1)
    put chr(floor(n/ex)) before s
    n = n mod ex
  end repeat
  return s
end

----------------------------------------
-- returns binary string interpreted as number (little-endian)
----------------------------------------
on getNum (binStr)
  n=0
  digits=binStr.length
  
  repeat with i = 1 to digits
    n=n+integer(power(256,i-1))*ord(binStr.char[i])
  end repeat
  return n
end

----------------------------------------
-- 
----------------------------------------
on getBmpFromDib (str)
  bmpHeader="BM"
  bfSize=14 + str.length --size, in bytes, of the bitmap file.
  dibHeaderSize=getNum(str.char[1..4])
  biBitCount = getNum(str.char[15..16])
  if biBitCount=8 then -- palette
    bfOffBits = 54 + 1024
  else -- no palette
    bfOffBits = 54
  end if
  put getBinStr(bfSize+2, 4) after bmpHeader
  put chr(0)&chr(0)&chr(0)&chr(0) after bmpHeader
  put getBinStr(bfOffBits, 4) after bmpHeader
  put bmpHeader before str
  put chr(0)&chr(0) after str
  return str
end

