-- Radio button behavior
property pS
property pM
property pButtonValue -- Value of radion button

property radioButtonGroup  -- Group radio button belongs to
property buttonGroupName   -- Button name in FDF form
property isDefault         -- Whether button is checked by default

property pActive


on beginSprite me
  pS = sprite(me.spriteNum)
  pM = pS.member
  pActive = 1
  sendAllSprites(#resetRadioButtons, me.radioButtonGroup)
end

on showRadio me, valueList
  --pS.visible = (valueList.getPos(pButtonValue))
  if valueList.getPos(pButtonValue) then 
    pS.blend = 100
    pActive = 1
  else 
    pS.blend = 25
    pActive = 0
  end if
end

on resetRadioButtons me, pButtonGroup, pObject  
  -- Turn off button hilighting if part of the group being called
  if pButtonGroup = me.radioButtonGroup then
    pM.hilite = me.isDefault --FALSE
  end if
end

on resetRadioButtonsFalse me, pButtonGroup, pObject
  -- Escape the call if made by same object
  if pObject = me then
    exit
  end if
  
  -- Turn off button hilighting if part of the group being called
  if pButtonGroup = me.radioButtonGroup then
    pM.hilite = FALSE
  end if
end

on mouseUp me
  if pActive = 0 then 
    pM.hilite = 0
    return
  end if
  
  -- Turn off all other button hilighting and enable the hilite
  -- of the clicked button
  sendAllSprites(#resetRadioButtonsFalse, me.radioButtonGroup, me)
  oldState = pM.hilite
  pM.hilite = TRUE
  if oldState then showData()
end


on appendFDFData me, tList
  -- If the hilite of the button is true, then add the name of
  -- the group and the value of the button to the list.
  if pM.hilite = TRUE then
    tList.setaProp(me.buttonGroupName, me.pButtonValue) --"/" &
  end if
end


on endSprite me
  pM.hilite = FALSE
end


on getPropertyDescriptionList me
  pl = [\
    #radioButtonGroup:    [#comment: "Radio button group:",\
                           #format : #integer,\
                           #default: 1],\
    #pButtonValue: [#comment: "Value passed out by button:",\
                           #format : #string,\
                           #default: EMPTY],\
    #isDefault          : [#comment: "Is button default selection:",\
                           #format : #boolean,\
                           #default: FALSE],\
    #buttonGroupName    : [#comment: "Name of radio button group in form:",\
                           #format : #string,\
                           #default: EMPTY]\
  ]
  
  return pl
end
